// Package common provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package common

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/nlfm"
)

// Defines values for Event.
const (
	EventFAILEDRESOURCESALLOCATION Event = "FAILED_RESOURCES_ALLOCATION"

	EventLOSSOFBEARER Event = "LOSS_OF_BEARER"

	EventRECOVERYOFBEARER Event = "RECOVERY_OF_BEARER"

	EventRELEASEOFBEARER Event = "RELEASE_OF_BEARER"

	EventSESSIONTERMINATION Event = "SESSION_TERMINATION"

	EventSUCCESSFULRESOURCESALLOCATION Event = "SUCCESSFUL_RESOURCES_ALLOCATION"

	EventUSAGEREPORT Event = "USAGE_REPORT"
)

// Defines values for ResultReason.
const (
	ResultReasonOTHERREASON ResultReason = "OTHER_REASON"

	ResultReasonROAMINGNOTALLOWED ResultReason = "ROAMING_NOT_ALLOWED"
)

// Represents an accumulated usage.
type AccumulatedUsage struct {
	// Unsigned integer identifying a volume in units of bytes.
	DownlinkVolume *Volume `json:"downlinkVolume,omitempty"`

	// Unsigned integer identifying a period of time in units of seconds.
	Duration *DurationSec `json:"duration,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	TotalVolume *Volume `json:"totalVolume,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	UplinkVolume *Volume `json:"uplinkVolume,omitempty"`
}

// Represents a successful acknowledgement of a notification.
type Acknowledgement struct {
	// A human-readable explanation specific to this successful acknowledgement
	Details string `json:"details"`
}

// integer indicating a bandwidth in bits per second.
type Bandwidth int

// string identifying a BDT Reference ID as defined in subclause 5.3.3 of 3GPP TS 29.154.
type BdtReferenceId string

// This data type is defined in the same way as the BdtReferenceId data type, but with the nullable property set to true.
type BdtReferenceIdRm string

// string with format "binary" as defined in OpenAPI Specification.
type Binary string

// String with format "byte" as defined in OpenAPI Specification, i.e, base64-encoded characters.
type Bytes string

// Represents one configuration processing result for a group's members.
type ConfigResult interface{}

// string with format "date-time" as defined in OpenAPI.
type DateTime time.Time

// string with format "date-time" as defined in OpenAPI with "nullable=true" property.
type DateTimeRm time.Time

// string with format "date-time" as defined in OpenAPI with "readOnly=true" property.
type DateTimeRo time.Time

// integer between and including 1 and 7 denoting a weekday. 1 shall indicate Monday, and the subsequent weekdays shall be indicated with the next higher numbers. 7 shall indicate Sunday.
type DayOfWeek int

// Unsigned integer identifying a period of time in units of minutes.
type DurationMin int32

// Unsigned integer identifying a period of time in units of seconds.
type DurationSec int

// Unsigned integer identifying a period of time in units of seconds with "nullable=true" property.
type DurationSecRm int

// Unsigned integer identifying a period of time in units of seconds with "readOnly=true" property.
type DurationSecRo int

// Possible values are - SESSION_TERMINATION: Indicates that Rx session is terminated. - LOSS_OF_BEARER : Indicates a loss of a bearer. - RECOVERY_OF_BEARER: Indicates a recovery of a bearer. - RELEASE_OF_BEARER: Indicates a release of a bearer. - USAGE_REPORT: Indicates the usage report event.  - FAILED_RESOURCES_ALLOCATION: Indicates the resource allocation is failed. - SUCCESSFUL_RESOURCES_ALLOCATION: Indicates the resource allocation is successful.
type Event string

// Represents an event report.
type EventReport struct {
	// Represents an accumulated usage.
	AccumulatedUsage *AccumulatedUsage `json:"accumulatedUsage,omitempty"`

	// Possible values are - SESSION_TERMINATION: Indicates that Rx session is terminated. - LOSS_OF_BEARER : Indicates a loss of a bearer. - RECOVERY_OF_BEARER: Indicates a recovery of a bearer. - RELEASE_OF_BEARER: Indicates a release of a bearer. - USAGE_REPORT: Indicates the usage report event.  - FAILED_RESOURCES_ALLOCATION: Indicates the resource allocation is failed. - SUCCESSFUL_RESOURCES_ALLOCATION: Indicates the resource allocation is successful.
	Event Event `json:"event"`

	// Identifies the IP flows that were sent during event subscription
	FlowIds *[]int `json:"flowIds,omitempty"`
}

// string containing a local identifier followed by "@" and a domain identifier. Both the local identifier and the domain identifier shall be encoded as strings that do not contain any "@" characters. See Clauses 4.6.2 and 4.6.3 of 3GPP TS 23.682 for more information.
type ExternalGroupId string

// string containing a local identifier followed by "@" and a domain identifier. Both the local identifier and the domain identifier shall be encoded as strings that do not contain any "@" characters. See Clause 4.6.2 of 3GPP TS 23.682 for more information.
type ExternalId string

// Represents flow information.
type FlowInfo struct {
	// Indicates the packet filters of the IP flow. Refer to subclause 5.3.8 of 3GPP TS 29.214 for encoding. It shall contain UL and/or DL IP flow description.
	FlowDescriptions *[]string `json:"flowDescriptions,omitempty"`

	// Indicates the IP flow.
	FlowId int `json:"flowId"`
}

// Represents the description of invalid parameters, for a request rejected due to invalid parameters.
type InvalidParam struct {
	// Attribute's name encoded as a JSON Pointer, or header's name.
	Param string `json:"param"`

	// A human-readable reason, e.g. "must be a positive integer".
	Reason *string `json:"reason,omitempty"`
}

// string identifying a Ipv4 address formatted in the "dotted decimal" notation as defined in IETF RFC 1166.
type Ipv4Addr string

// string identifying a Ipv4 address formatted in the "dotted decimal" notation as defined in IETF RFC 1166, with "readOnly=true" property.
type Ipv4AddrRo string

// string identifying a Ipv6 address formatted according to clause 4 in IETF RFC 5952. The mixed Ipv4 Ipv6 notation according to clause 5 of IETF RFC 5952 shall not be used.
type Ipv6Addr string

// string identifying a Ipv6 address formatted according to clause 4 in IETF RFC 5952, with "readOnly=true" property. The mixed Ipv4 Ipv6 notation according to clause 5 of IETF RFC 5952 shall not be used.
type Ipv6AddrRo string

// string formatted according to IETF RFC 3986 identifying a referenced resource.
type Link string

// Represents a user location area.
type LocationArea struct {
	// Indicates a list of Cell Global Identities of the user which identifies the cell the UE is registered.
	CellIds *[]string `json:"cellIds,omitempty"`

	// Identifies a list of civic addresses of the user where the UE is located.
	CivicAddresses *[]externalRef1.CivicAddress `json:"civicAddresses,omitempty"`

	// Indicates a list of eNodeB identities in which the UE is currently located.
	EnodeBIds *[]string `json:"enodeBIds,omitempty"`

	// Identifies a list of geographic area of the user where the UE is located.
	GeographicAreas *[]externalRef1.GeographicArea `json:"geographicAreas,omitempty"`

	// Identifies a list of Routing Area Identities of the user where the UE is located.
	RoutingAreaIds *[]string `json:"routingAreaIds,omitempty"`

	// Identifies a list of Tracking Area Identities of the user where the UE is located.
	TrackingAreaIds *[]string `json:"trackingAreaIds,omitempty"`
}

// Represents a user location area when the UE is attached to 5G.
type LocationArea5G struct {
	// Identifies a list of civic addresses of the user where the UE is located.
	CivicAddresses *[]externalRef1.CivicAddress `json:"civicAddresses,omitempty"`

	// Identifies a list of geographic area of the user where the UE is located.
	GeographicAreas *[]externalRef1.GeographicArea `json:"geographicAreas,omitempty"`
}

// String encoding a Mobile Country Code part of the PLMN, comprising 3 digits, as defined in 3GPP TS 38.413.
type Mcc string

// String encoding a Mobile Network Code part of the PLMN, comprising 2 or 3 digits, as defined in 3GPP TS 38.413.
type Mnc string

// string formatted according to subclause 3.3 of 3GPP TS 23.003 that describes an MSISDN.
type Msisdn string

// Represents the information to be conveyed in a bearer level event(s) notification.
type NotificationData struct {
	// Contains the reported event and applicable information
	EventReports []EventReport `json:"eventReports"`

	// string formatted according to IETF RFC 3986 identifying a referenced resource.
	Transaction Link `json:"transaction"`
}

// Represents the identifier of a PLMN.
type PlmnId struct {
	// String encoding a Mobile Country Code part of the PLMN, comprising 3 digits, as defined in 3GPP TS 38.413.
	Mcc Mcc `json:"mcc"`

	// String encoding a Mobile Network Code part of the PLMN, comprising 2 or 3 digits, as defined in 3GPP TS 38.413.
	Mnc Mnc `json:"mnc"`
}

// Unsigned integer with valid values between 0 and 65535.
type Port int

// Unsigned integer with valid values between 0 and 65535, with "readOnly=true" property.
type PortRo int

// Represents additional information and details on an error response.
type ProblemDetails struct {
	// A machine-readable application error cause specific to this occurrence of the problem. This IE should be present and provide application-related error information, if available.
	Cause *string `json:"cause,omitempty"`

	// A human-readable explanation specific to this occurrence of the problem.
	Detail *string `json:"detail,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	Instance *Uri `json:"instance,omitempty"`

	// Description of invalid parameters, for a request rejected due to invalid parameters.
	InvalidParams *[]InvalidParam `json:"invalidParams,omitempty"`

	// The HTTP status code for this occurrence of the problem.
	Status *int `json:"status,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures *externalRef0.SupportedFeatures `json:"supportedFeatures,omitempty"`

	// A short, human-readable summary of the problem type. It should not change from occurrence to occurrence of the problem.
	Title *string `json:"title,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	Type *Uri `json:"type,omitempty"`
}

// string chosen by the SCEF to serve as identifier in a resource URI.
type ResourceId string

// Possible values are - ROAMING_NOT_ALLOWED: Identifies the configuration parameters are not allowed by roaming agreement. - OTHER_REASON: Identifies the configuration parameters are not configured due to other reason.
type ResultReason string

// string that identifies an SCS/AS.
type ScsAsId string

// Represents a sponsor information.
type SponsorInformation struct {
	// It indicates Application Service Provider ID.
	AspId string `json:"aspId"`

	// It indicates Sponsor ID.
	SponsorId string `json:"sponsorId"`
}

// Represents a notification that can be sent to test whether a chosen notification mechanism works.
type TestNotification struct {
	// string formatted according to IETF RFC 3986 identifying a referenced resource.
	Subscription Link `json:"subscription"`
}

// String with format partial-time or full-time as defined in subclause 5.6 of IETF RFC 3339. Examples, 20:15:00, 20:15:00-08:00 (for 8 hours behind UTC).
type TimeOfDay string

// Represents a time window identified by a start time and a stop time.
type TimeWindow struct {
	// string with format "date-time" as defined in OpenAPI.
	StartTime DateTime `json:"startTime"`

	// string with format "date-time" as defined in OpenAPI.
	StopTime DateTime `json:"stopTime"`
}

// string providing an URI formatted according to IETF RFC 3986.
type Uri string

// Represents a usage threshold.
type UsageThreshold struct {
	// Unsigned integer identifying a volume in units of bytes.
	DownlinkVolume *Volume `json:"downlinkVolume,omitempty"`

	// Unsigned integer identifying a period of time in units of seconds.
	Duration *DurationSec `json:"duration,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	TotalVolume *Volume `json:"totalVolume,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	UplinkVolume *Volume `json:"uplinkVolume,omitempty"`
}

// Represents the same as the UsageThreshold data type but with the nullable:true property.
type UsageThresholdRm struct {
	// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
	DownlinkVolume *VolumeRm `json:"downlinkVolume"`

	// Unsigned integer identifying a period of time in units of seconds with "nullable=true" property.
	Duration *DurationSecRm `json:"duration"`

	// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
	TotalVolume *VolumeRm `json:"totalVolume"`

	// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
	UplinkVolume *VolumeRm `json:"uplinkVolume"`
}

// Unsigned integer identifying a volume in units of bytes.
type Volume int64

// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
type VolumeRm int64

// Represents the configuration information for the delivery of notifications over Websockets.
type WebsockNotifConfig struct {
	// Set by the SCS/AS to indicate that the Websocket delivery is requested.
	RequestWebsocketUri *bool `json:"requestWebsocketUri,omitempty"`

	// string formatted according to IETF RFC 3986 identifying a referenced resource.
	WebsocketUri *Link `json:"websocketUri,omitempty"`
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+Rb727juHZ/lQO1wN1FFcWxk8xMgAL1OM5cF0lsWM4uis0ioKVjizcSqZKUPb6LPFBf",
	"o09WkJRsyZYte2Z30/Z+2R3HPOTvHPL8P/7NCXiScoZMSefmN0egTDmTaD50Wh/0/0KUgaCpopw5N84E",
	"k5QLIlYwxpAKDJTjOhGSEIUhuucBsUu3KbsMSKxQMKLoAuFpPAA+AxUhCJQ8EwF6jusI/M+MCgydGyUy",
	"dB0ZRJgQvZtapejcOFIJyubO29vbm+t0Wh93DxqhSIhm6X8FxMtWS38VcKaQKf1PkqYxtRDOU8GnMSb/",
	"8jdp8Wz2+meBM+fG+afzzQ2d22/l+chS3aIiNJaOOafKyWcSgsaJUjkGxMU7gHhiJFMRF/TvGFoUnXdA",
	"ccfFlIYhMgvh8h0gPHIFdzxjuRSu3wlCNwgwVWQao8Xx6R1w9DibxTSwr/LiPV7lPbK5imBcaLEB0n4H",
	"ICOBAWch1R/hjtC4APMeWjIiq5iTECacwz0Rc/tELt5DW7TZNTC4NqIaxdW7GC+ZpSkXCkN4wJASmGjr",
	"rvG030NxtEQeCFuZh4tSSQ3l6l2cy4AZHxmDj2KBAvpCcGHhvMfT1ShogPDEyILQuLBvIc5IFqtdL/8F",
	"GQoaFLDfCg9ugoNuEGRJFhOF4ZMkc9wlH2MqUGqMQBiQzXrINIGOEFLBUxSK2jgq5EsWU/b6E4+zBJv4",
	"zVdpBjKxjlMOUdzm63wMNJniisSnnpWlpyPUZ9mAh0//htakd4NXxpcxhnNM8iewX3ogsyBAKWdZDKRK",
	"qOMuAowrOsufT41c8yexG8ZBlCWEnQkkoX4NgF/TmDCzDcgUA70pKA4qovIACMfdiejK0d8vawS/1kji",
	"M2HhkoYq2sVHmcI5CqAsNMyxORCYFuuBMphSJSFFAdK4CM17QhlNssS5aa0Py/cxp4VqjDMUyAIchLtH",
	"WgaAhsgUna3skZ9vJ7CmgsEtEAkhzijDUIOQ2TSISSYRrryO19FX0vkyGsHEh/Yn7+Lq0tsV0DaScVKT",
	"Qmiph0QR0MRAK4fqYFuSBGFJVhqP/lzdckPqwjRTsKQqMstYFhvlh/yZrECiMtcsMqOWxYIicN/FThkR",
	"q73SMyfNuEiIgmdnahY/O1tSG6bIuqMB+Pk7Wz/e3dNWCmter1972ErhcUe5QD0tGSLx+vIMWcBDDCGI",
	"iCCBQiFroeiojM7HKGsNZklnOUMIzOLc6Ghha/XRkIWh16CBwFzwLP2LhASTaX4sZzicOTe//FZRIvxq",
	"vckglM6vb271y0RSGTL9xa/b6l+m24HcJ0EEGFtbkusZGoNdkBW6QFEUSd5TX6OkChPZZAP768O1+BLK",
	"BpbqYi1cIgRZmS9zFhowFmjsk3/wgRZeduRPHs8H/u0jsEzLEkgc6xQWQyPqE5E/GDiNqO1djpHIZgc0",
	"Lq/dtpGVjeoM5S1ROKEJHql2IVF4pmiyVx20JOxq52azuu7VFyfXGalvO9uuf15bmn/VhubZWVukvdga",
	"TdMaK/+9sWovOWTx6misBcEBrKvh7GfE1/2ub4pqiciAMA0piLNQc3BhPn+AELXnNz5qifgakpUHFyAj",
	"EsdrZYYHzkKycg2J8RrZVOrQmKmCSOYkU1xThSV3gV8VRHQeocgVS3rwYfsUP9OnGAdMvloH/KHkjC/q",
	"nHERkD3QmhrTE5N0bm8ijwIqPjlFQXloLBJNNG7ImA4G+AwSyjKFsnIvlKlOuzE6KEeIvyMgG5xI75Tz",
	"63TtuxEco3ZlhHu0bQ9i/gciPqR8ZcR7dK6EuL+ojbdHXEqqg6IFiTPtAQXCGfh93x8MH18m/fHD4LE7",
	"GQwfb2CwdpMqIgrGX0Fqx86ZDtEUioQyrUEenMH90Pdfhncvn/vdcX8MZVoCMZfSxu9TJAKFJhj3e8Of",
	"+uP/2BBVaQQGfIFitUt33+/6/f1kMRKJ21RPfvdL/2XcHw3HkypfaJM0EKhTe0AtNA/gDO66g/v+7cu4",
	"7w+fxr2+/9K9vx/2aiSzqQUXfjiX0MxUcPTx/lOv1/f9u6f779lvk5d4z8xxHWT6Lfzi1Nyd4zrVG3Fc",
	"Z1fi5o9b4nRcpywsx3UOCMJxnQbWSg5+4w7MyxwbgTdl0+Y+8svZTfhITW5+KC7ZyeXfXAcLNTkY3ZlF",
	"b64zi/myNr4cVMO1wQj00lxzligQNE8QZsYzW7a0g1pvUYrWdnX5QGS2FV1ZdurCqiJC/aLj8AMpYcCZ",
	"IpRZw6XfXyUynvE45ksMYbqCZ+ffdCzBQiAQ8oRQVlrpwWeeO9adTQoPvUO08c9FnkIkWFy5KEMOjKsC",
	"JBBWwCglNOAjQs9kqhIuvWuvbU7U/6omrR3v+mPbxMwJF9osWze6Lz8rxfj/EMLLZfcdErvT6sJm/KCa",
	"a0XZ3qmq53rF7Ya8Tv0qBjQlwSsqmNFYs1Rkc7lOerbEAYpvFTQ+bhU02heXhlMjTcrmHgxULuNCgk/3",
	"+jrOuYDb+2J/KCHzatR6I52EfM21ut2QfFmz08R2waCzGw5sWYl8vzozMWALEtNwRARJDl6beYObL7Xw",
	"qKWFVBOjlr2bJ/956xEE6nMwhDBDfQO7FLu3n9ZD6Sol6DRT+BcJjCSVV0/g3/3hI4y4yZld4AJsvzdf",
	"W/tYxTq3bage2oUuoDf34NlJMqm01hFIuaSmUZzL/dnxGkuGlrvam0gXl90wFEcW7/RyIGEoUMo861Ob",
	"EtqzE3LzOcSAJiR+drQpsLFFNRsc9Cd3ML7rwcXF9XWtoApgB1LPPwGae0zI3JiaDtLF9WlCvq7hhAQB",
	"FyZjVRxyk3JZQXz16artwSRCSOhXDK1IzG4bXms2udJqVdkkt0Dajk918Irhvju6PvWOvp2z5rv441hv",
	"vOJ7yl73CmEPp+tzO58+Xm9JShSl57AyBbJ7bh67dwWShr5HJlHAOtYnAsmuGQwwri9tVlItKk2rpIdx",
	"DF9iPiUx2NBUb1N4QnPcMqJBtF1m1IfkBUSdcgicU6lQWEkf8GSHnFdAFzTo2peFh0PnDQOGqHiPO8h1",
	"PL1BmRc/6yqeE7/96epD++UxTmYvxYV4K5LEtXF+rwS1kS9kPMTPR18JPurlucDNbVCWX8KGlSATApmK",
	"V7VMnSb3OfK5IGlEA/0CjxX8hsq8wz9J8F8qWJuL0TxTlM312qZsbMPZ2BKBptqvFM0cnnYLSpDg9WSs",
	"k5zqTwVb178tG7GrLyebMY2RlSASpUgQYaht7NWXGiP3f9dW/P9Sv+aX8RAEe3uVRcoEBB74lMYIPZ4x",
	"JVbQ46HOz4QqOBvdPzy6oDEJapqGHQjpnCrpbgV/RWbW+ehdXnRqPe4DOwXSI6olF69HQGrrBOJ7cNkW",
	"24kxyCY77ezULVqtTp7Smw2ntpX54A/828daCI+lyYlbokhjaldKyDWYqWnzLnBlmS6KqxDjAmNbz/pB",
	"/tgwoIGbwl+NPvRsUl3UQPNRK1sqM3USOzqkM7ASuKMbtKWi4xE2m0kSHDNrY4LL7ZyuTO9Wua5L9EZx",
	"wuqy++0bqfSniXmmuzJOrFoe7PgGZi4oYc0rWbDDnD7AEtfyUlvU3WmPmHTBpv55H6JoALbMXV9fXXWu",
	"Kk0285emvpI+/aj2zFHnH5VhHgLY3KTZGmY76F5DOxlK4opuarT52BGYj4BCcAHF5H6Nj9U2pa7MkZAg",
	"ogw3hY7SsF6+q6HdHZnigQ1cAyxsaD7bp/M+KmHQBxnxLA61Hck5MshTwRc0rJx0JtBOz9kTS7y6QGew",
	"HumrNXNWEt87AbafnbozKZOKsKCx+/AkqF2+KbDV3PjtH1NSO8pGVmp/TUZSKqIyWTfNhfDXyWQEdgEE",
	"2r3auZQjRVvSj/XI7R0SlQncjXEuXno8SaxT2x/g+Dv7aDNPVVyrCDLiQrnbT0ZmSUJsR7KE2wye5aVh",
	"88JNhT0ibI4wEzwpc6z4iU/L/uGIZ1UXoI3z4sShdkXEJTKYrgwSv9e/M4EHigXqKKfkcYzPXzcmn8aD",
	"WrzjrSGhY1rP42H3YfD45eVxODGNw5/7tzew1U7bmjBbv2yzhRY42TRWBCeJifPmAs0olQdnMJz8tT9+",
	"Gfe7vmm3nrh7sWCjZFxFKPJCcLUbW8OO4zrl82t7on4gu/LATZlgr1SsIQz8nn/e9Wvvwdemn4tBKUxq",
	"GLy1BIfbMETW9g0H5YG6bsllFHPYI2vkBQxua9HmhzfunXNVv81WlLLZ081x10UrE5SqHBk3SKkc3dob",
	"CQjTLs34M+09tEFeRmheBynUq0KWoDYOVCagk4+adkelK/wt0Wdlg1quaYLD2S1ZHTVrqjMjSmIz7KXz",
	"oFkW5x/2TwdfV2q3nU7nkwf9ryRJY5QutFs3F1c3rdbmX2etjzetFvyg3cRHiHgmdEAWURbC06T3Y+2r",
	"0Vz8TFnIlw23ZrAuzcqNBhlTQbSPEsqusK1YqXhqPtdcjF5bDCYenL8vBhiNl+TpaTTbt7k+tbRZ3a1q",
	"P7DPetgwy1hFZn7FeEzZu1bqZm5iEgmUEY/DxnoQmSOoYvU/9i8hqpIbNzdXzdR7PvFeJS4Ny9cOvJt0",
	"o5KlbA+4ff81jJNvvAhLePJVWLLTL0PT1V3HZo+TJvkWhqwywTdd1QxhXl82DkGu8f1eGE4aNq7D2DwG",
	"+TNOJQ9ejc+0vxFofMbV6KqcuhbD6iHGtJj1K/tKCXyBAvIzUdU4yzwJWi+pNYI+qk2Iq2MmmyblA73G",
	"j+vv1ptsAJkWmDmh0madch4jMTPzy62Tj/LWW49R/6n4FcItD2pyqvLPbNpt+Onig9fxWjD5uGlGQsop",
	"s7+1eORCRVOesRC6o4F0XCcTsXPjREqlN+fny+XS68zT1ONifj5T6bmfYiDPiQgiusDz9qcXiYKiPLen",
	"nduktW6I57YwQ7JcnDMZxAIFic3x3jP77/+Cdqt94doK5lDMCaN/J3kxY0SEYjra/qE7Hnx2oTsZ+C70",
	"en7Xhf7EH7gw8W/N/yZd/Z/ej94z68YxCDqPlL4gk6+ENgzPczpnIyybHoLBOtFYHddZoJCWhQuv7bXO",
	"SJxGxLvUnPIUGUmpFrrX8lr6xREV6Tt5e/ufAAAA//+j6dNYHkEAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29572_Nlmf_Location.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
