// Package nlfm provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package nlfm

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
)

const (
	OAuth2ClientCredentialsScopes = "oAuth2ClientCredentials.Scopes"
)

// Defines values for AccuracyFulfilmentIndicator.
const (
	AccuracyFulfilmentIndicatorREQUESTEDACCURACYFULFILLED AccuracyFulfilmentIndicator = "REQUESTED_ACCURACY_FULFILLED"

	AccuracyFulfilmentIndicatorREQUESTEDACCURACYNOTFULFILLED AccuracyFulfilmentIndicator = "REQUESTED_ACCURACY_NOT_FULFILLED"
)

// Defines values for EventClass.
const (
	EventClassSUPPLEMENTARYSERVICES EventClass = "SUPPLEMENTARY_SERVICES"
)

// Defines values for ExternalClientType.
const (
	ExternalClientTypeEMERGENCYSERVICES ExternalClientType = "EMERGENCY_SERVICES"

	ExternalClientTypeLAWFULINTERCEPTSERVICES ExternalClientType = "LAWFUL_INTERCEPT_SERVICES"

	ExternalClientTypePLMNOPERATORANONYMOUSSTATISTICS ExternalClientType = "PLMN_OPERATOR_ANONYMOUS_STATISTICS"

	ExternalClientTypePLMNOPERATORBROADCASTSERVICES ExternalClientType = "PLMN_OPERATOR_BROADCAST_SERVICES"

	ExternalClientTypePLMNOPERATOROM ExternalClientType = "PLMN_OPERATOR_OM"

	ExternalClientTypePLMNOPERATORSERVICES ExternalClientType = "PLMN_OPERATOR_SERVICES"

	ExternalClientTypePLMNOPERATORTARGETMSSERVICESUPPORT ExternalClientType = "PLMN_OPERATOR_TARGET_MS_SERVICE_SUPPORT"

	ExternalClientTypeVALUEADDEDSERVICES ExternalClientType = "VALUE_ADDED_SERVICES"
)

// Defines values for GnssId.
const (
	GnssIdBDS GnssId = "BDS"

	GnssIdGALILEO GnssId = "GALILEO"

	GnssIdGLONASS GnssId = "GLONASS"

	GnssIdGPS GnssId = "GPS"

	GnssIdMODERNIZEDGPS GnssId = "MODERNIZED_GPS"

	GnssIdNAVIC GnssId = "NAVIC"

	GnssIdQZSS GnssId = "QZSS"

	GnssIdSBAS GnssId = "SBAS"
)

// Defines values for LcsPriority.
const (
	LcsPriorityHIGHESTPRIORITY LcsPriority = "HIGHEST_PRIORITY"

	LcsPriorityNORMALPRIORITY LcsPriority = "NORMAL_PRIORITY"
)

// Defines values for LcsQosClass.
const (
	LcsQosClassASSURED LcsQosClass = "ASSURED"

	LcsQosClassBESTEFFORT LcsQosClass = "BEST_EFFORT"

	LcsQosClassMULTIPLEQOS LcsQosClass = "MULTIPLE_QOS"
)

// Defines values for LdrType.
const (
	LdrTypeBEINGINSIDEAREA LdrType = "BEING_INSIDE_AREA"

	LdrTypeENTERINGINTOAREA LdrType = "ENTERING_INTO_AREA"

	LdrTypeLEAVINGFROMAREA LdrType = "LEAVING_FROM_AREA"

	LdrTypeMOTION LdrType = "MOTION"

	LdrTypePERIODIC LdrType = "PERIODIC"

	LdrTypeUEAVAILABLE LdrType = "UE_AVAILABLE"
)

// Defines values for OccurrenceInfo.
const (
	OccurrenceInfoMULTIPLETIMEEVENT OccurrenceInfo = "MULTIPLE_TIME_EVENT"

	OccurrenceInfoONETIMEEVENT OccurrenceInfo = "ONE_TIME_EVENT"
)

// Defines values for PositioningMethod.
const (
	PositioningMethodBAROMETRICPRESSURE PositioningMethod = "BAROMETRIC_PRESSURE"

	PositioningMethodBLUETOOTH PositioningMethod = "BLUETOOTH"

	PositioningMethodCELLID PositioningMethod = "CELLID"

	PositioningMethodDLAOD PositioningMethod = "DL_AOD"

	PositioningMethodDLTDOA PositioningMethod = "DL_TDOA"

	PositioningMethodECID PositioningMethod = "ECID"

	PositioningMethodMBS PositioningMethod = "MBS"

	PositioningMethodMOTIONSENSOR PositioningMethod = "MOTION_SENSOR"

	PositioningMethodMULTIRTT PositioningMethod = "MULTI-RTT"

	PositioningMethodNETWORKSPECIFIC PositioningMethod = "NETWORK_SPECIFIC"

	PositioningMethodNRECID PositioningMethod = "NR_ECID"

	PositioningMethodOTDOA PositioningMethod = "OTDOA"

	PositioningMethodULAOA PositioningMethod = "UL_AOA"

	PositioningMethodULTDOA PositioningMethod = "UL_TDOA"

	PositioningMethodWLAN PositioningMethod = "WLAN"
)

// Defines values for PositioningMode.
const (
	PositioningModeCONVENTIONAL PositioningMode = "CONVENTIONAL"

	PositioningModeUEASSISTED PositioningMode = "UE_ASSISTED"

	PositioningModeUEBASED PositioningMode = "UE_BASED"
)

// Defines values for ReportedEventType.
const (
	ReportedEventTypeBEINGINSIDEAREAEVENT ReportedEventType = "BEING_INSIDE_AREA_EVENT"

	ReportedEventTypeENTERINGAREAEVENT ReportedEventType = "ENTERING_AREA_EVENT"

	ReportedEventTypeLEAVINGAREAEVENT ReportedEventType = "LEAVING_AREA_EVENT"

	ReportedEventTypeLOCATIONCANCELLATIONEVENT ReportedEventType = "LOCATION_CANCELLATION_EVENT"

	ReportedEventTypeMAXIMUMINTERVALEXPIRATIONEVENT ReportedEventType = "MAXIMUM_INTERVAL_EXPIRATION_EVENT"

	ReportedEventTypeMOTIONEVENT ReportedEventType = "MOTION_EVENT"

	ReportedEventTypePERIODICEVENT ReportedEventType = "PERIODIC_EVENT"
)

// Defines values for ReportingAccessType.
const (
	ReportingAccessTypeEUTRACONNECTEDTO5GC ReportingAccessType = "EUTRA_CONNECTED_TO_5GC"

	ReportingAccessTypeNON3GPPCONNECTEDTO5GC ReportingAccessType = "NON_3GPP_CONNECTED_TO_5GC"

	ReportingAccessTypeNR ReportingAccessType = "NR"

	ReportingAccessTypeNRGEO ReportingAccessType = "NR_GEO"

	ReportingAccessTypeNRLEO ReportingAccessType = "NR_LEO"

	ReportingAccessTypeNRMEO ReportingAccessType = "NR_MEO"

	ReportingAccessTypeNROTHERSAT ReportingAccessType = "NR_OTHER_SAT"
)

// Defines values for ReportingAreaType.
const (
	ReportingAreaTypeEPSTRACKINGAREAIDENTITY ReportingAreaType = "EPS_TRACKING_AREA_IDENTITY"

	ReportingAreaTypeEUTRANCELLGLOBALIDENTIFICATION ReportingAreaType = "E-UTRAN_CELL_GLOBAL_IDENTIFICATION"

	ReportingAreaTypeN5GSTRACKINGAREAIDENTITY ReportingAreaType = "5GS_TRACKING_AREA_IDENTITY"

	ReportingAreaTypeNRCELLGLOBALIDENTITY ReportingAreaType = "NR_CELL_GLOBAL_IDENTITY"
)

// Defines values for ResponseTime.
const (
	ResponseTimeDELAYTOLERANT ResponseTime = "DELAY_TOLERANT"

	ResponseTimeLOWDELAY ResponseTime = "LOW_DELAY"

	ResponseTimeNODELAY ResponseTime = "NO_DELAY"
)

// Defines values for SupportedGADShapes.
const (
	SupportedGADShapesELLIPSOIDARC SupportedGADShapes = "ELLIPSOID_ARC"

	SupportedGADShapesLOCAL2DPOINTUNCERTAINTYELLIPSE SupportedGADShapes = "LOCAL_2D_POINT_UNCERTAINTY_ELLIPSE"

	SupportedGADShapesLOCAL3DPOINTUNCERTAINTYELLIPSOID SupportedGADShapes = "LOCAL_3D_POINT_UNCERTAINTY_ELLIPSOID"

	SupportedGADShapesPOINT SupportedGADShapes = "POINT"

	SupportedGADShapesPOINTALTITUDE SupportedGADShapes = "POINT_ALTITUDE"

	SupportedGADShapesPOINTALTITUDEUNCERTAINTY SupportedGADShapes = "POINT_ALTITUDE_UNCERTAINTY"

	SupportedGADShapesPOINTUNCERTAINTYCIRCLE SupportedGADShapes = "POINT_UNCERTAINTY_CIRCLE"

	SupportedGADShapesPOINTUNCERTAINTYELLIPSE SupportedGADShapes = "POINT_UNCERTAINTY_ELLIPSE"

	SupportedGADShapesPOLYGON SupportedGADShapes = "POLYGON"
)

// Defines values for TerminationCause.
const (
	TerminationCauseNORMALTERMINATION TerminationCause = "NORMAL_TERMINATION"

	TerminationCauseTERMINATIONBYNETWORK TerminationCause = "TERMINATION_BY_NETWORK"

	TerminationCauseTERMINATIONBYUE TerminationCause = "TERMINATION_BY_UE"
)

// Defines values for UeLocationServiceInd.
const (
	UeLocationServiceIndLOCATIONASSISTANCEDATA UeLocationServiceInd = "LOCATION_ASSISTANCE_DATA"

	UeLocationServiceIndLOCATIONESTIMATE UeLocationServiceInd = "LOCATION_ESTIMATE"
)

// Defines values for Usage.
const (
	UsageSUCCESSMETHODNOTDETERMINED Usage = "SUCCESS_METHOD_NOT_DETERMINED"

	UsageSUCCESSRESULTSNOTUSED Usage = "SUCCESS_RESULTS_NOT_USED"

	UsageSUCCESSRESULTSUSEDTOGENERATELOCATION Usage = "SUCCESS_RESULTS_USED_TO_GENERATE_LOCATION"

	UsageSUCCESSRESULTSUSEDTOVERIFYLOCATION Usage = "SUCCESS_RESULTS_USED_TO_VERIFY_LOCATION"

	UsageUNSUCCESS Usage = "UNSUCCESS"
)

// Defines values for VelocityRequested.
const (
	VelocityRequestedVELOCITYISNOTREQUESTED VelocityRequested = "VELOCITY_IS_NOT_REQUESTED"

	VelocityRequestedVELOCITYISREQUESTED VelocityRequested = "VELOCITY_IS_REQUESTED"
)

// Defines values for VerticalDirection.
const (
	VerticalDirectionDOWNWARD VerticalDirection = "DOWNWARD"

	VerticalDirectionUPWARD VerticalDirection = "UPWARD"
)

// Indicates value of accuracy.
type Accuracy float32

// Indicates fulfilment of requested accuracy.
type AccuracyFulfilmentIndicator string

// Indicates value of the age of the location estimate.
type AgeOfLocationEstimate int

// Indicates value of altitude.
type Altitude float64

// Indicates value of angle.
type Angle int

// Indicates the information of area based event reporting.
type AreaEventInfo struct {
	AreaDefinition []ReportingArea `json:"areaDefinition"`

	// Maximum interval between event reports.
	MaximumInterval *MaximumInterval `json:"maximumInterval,omitempty"`

	// Minimum interval between event reports.
	MinimumInterval *MinimumInterval `json:"minimumInterval,omitempty"`

	// Specifies occurrence of event reporting.
	OccurrenceInfo *OccurrenceInfo `json:"occurrenceInfo,omitempty"`

	// Maximum duration of event reporting.
	ReportingDuration    *ReportingDuration `json:"reportingDuration,omitempty"`
	ReportingLocationReq *bool              `json:"reportingLocationReq,omitempty"`

	// Maximum time interval between consecutive evaluations by a UE of a trigger event.
	SamplingInterval *SamplingInterval `json:"samplingInterval,omitempty"`
}

// Specifies the measured uncompensated atmospheric pressure.
type BarometricPressure int

// Information within Cancel Location Request.
type CancelLocData struct {
	// String providing an URI formatted according to RFC 3986
	HgmlcCallBackURI externalRef0.Uri `json:"hgmlcCallBackURI"`

	// LDR Reference.
	LdrReference LdrReference `json:"ldrReference"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures *externalRef0.SupportedFeatures `json:"supportedFeatures,omitempty"`
}

// Indicates a Civic address.
type CivicAddress struct {
	A1         *string `json:"A1,omitempty"`
	A2         *string `json:"A2,omitempty"`
	A3         *string `json:"A3,omitempty"`
	A4         *string `json:"A4,omitempty"`
	A5         *string `json:"A5,omitempty"`
	A6         *string `json:"A6,omitempty"`
	ADDCODE    *string `json:"ADDCODE,omitempty"`
	BLD        *string `json:"BLD,omitempty"`
	FLR        *string `json:"FLR,omitempty"`
	HNO        *string `json:"HNO,omitempty"`
	HNS        *string `json:"HNS,omitempty"`
	LMK        *string `json:"LMK,omitempty"`
	LOC        *string `json:"LOC,omitempty"`
	NAM        *string `json:"NAM,omitempty"`
	PC         *string `json:"PC,omitempty"`
	PCN        *string `json:"PCN,omitempty"`
	PLC        *string `json:"PLC,omitempty"`
	POBOX      *string `json:"POBOX,omitempty"`
	POD        *string `json:"POD,omitempty"`
	POM        *string `json:"POM,omitempty"`
	PRD        *string `json:"PRD,omitempty"`
	PRM        *string `json:"PRM,omitempty"`
	RD         *string `json:"RD,omitempty"`
	RDBR       *string `json:"RDBR,omitempty"`
	RDSEC      *string `json:"RDSEC,omitempty"`
	RDSUBBR    *string `json:"RDSUBBR,omitempty"`
	ROOM       *string `json:"ROOM,omitempty"`
	SEAT       *string `json:"SEAT,omitempty"`
	STS        *string `json:"STS,omitempty"`
	UNIT       *string `json:"UNIT,omitempty"`
	Country    *string `json:"country,omitempty"`
	Method     *string `json:"method,omitempty"`
	ProvidedBy *string `json:"providedBy,omitempty"`
	UsageRules *string `json:"usageRules,omitempty"`
}

// Indicates value of confidence.
type Confidence int

// LCS Correlation ID.
type CorrelationID string

// EllipsoidArc defines model for EllipsoidArc.
type EllipsoidArc struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Indicates value of angle.
	IncludedAngle Angle `json:"includedAngle"`

	// Indicates value of the inner radius.
	InnerRadius InnerRadius `json:"innerRadius"`

	// Indicates value of angle.
	OffsetAngle Angle `json:"offsetAngle"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Indicates value of uncertainty.
	UncertaintyRadius Uncertainty `json:"uncertaintyRadius"`
}

// Specifies event classes.
type EventClass string

// Information within Event Notify Request.
type EventNotifyData struct {
	// Contain Minor Location QoS.
	AchievedQos *MinorLocationQoS `json:"achievedQos,omitempty"`

	// Indicates value of the age of the location estimate.
	AgeOfLocationEstimate *AgeOfLocationEstimate `json:"ageOfLocationEstimate,omitempty"`

	// Indicates value of altitude.
	Altitude *Altitude `json:"altitude,omitempty"`

	// Indicates a Civic address.
	CivicAddress            *CivicAddress                    `json:"civicAddress,omitempty"`
	GnssPositioningDataList *[]GnssPositioningMethodAndUsage `json:"gnssPositioningDataList,omitempty"`

	// String identifying a Gpsi shall contain either an External Id or an MSISDN.  It shall be formatted as follows -External Identifier= "extid-<extid>, where <extid>  shall be formatted according to clause 19.7.2 of 3GPP TS 23.003 that describes an  External Identifier.
	Gpsi *externalRef0.Gpsi `json:"gpsi,omitempty"`

	// String providing an URI formatted according to RFC 3986
	HgmlcCallBackURI *externalRef0.Uri `json:"hgmlcCallBackURI,omitempty"`

	// LDR Reference.
	LdrReference LdrReference `json:"ldrReference"`

	// Local area specified by different shape
	LocalLocationEstimate *LocalArea `json:"localLocationEstimate,omitempty"`

	// Geographic area specified by different shape.
	LocationEstimate    *GeographicArea              `json:"locationEstimate,omitempty"`
	PositioningDataList *[]PositioningMethodAndUsage `json:"positioningDataList,omitempty"`

	// Specifies type of event reporting.
	ReportedEventType ReportedEventType `json:"reportedEventType"`

	// LMF identification.
	ServingLMFidentification *LMFIdentification `json:"servingLMFidentification,omitempty"`

	// String identifying a Supi that shall contain either an IMSI, a network specific identifier, a Global Cable Identifier (GCI) or a Global Line Identifier (GLI) as specified in clause 2.2A of 3GPP TS 23.003. It shall be formatted as follows
	//  - for an IMSI "imsi-<imsi>", where <imsi> shall be formatted according to clause 2.2 of 3GPP TS 23.003 that describes an IMSI.
	//  - for a network specific identifier "nai-<nai>, where <nai> shall be formatted according to clause 28.7.2 of 3GPP TS 23.003 that describes an NAI.
	//  - for a GCI "gci-<gci>", where <gci> shall be formatted according to clause 28.15.2 of 3GPP TS 23.003.
	//  - for a GLI "gli-<gli>", where <gli> shall be formatted according to clause 28.16.2 of 3GPP TS 23.003.To enable that the value is used as part of an URI, the string shall only contain characters allowed according to the "lower-with-hyphen" naming convention defined in 3GPP TS 29.501.
	Supi *externalRef0.Supi `json:"supi,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures *externalRef0.SupportedFeatures `json:"supportedFeatures,omitempty"`

	// Specifies causes of event reporting termination.
	TerminationCause *TerminationCause `json:"terminationCause,omitempty"`

	// string with format 'date-time' as defined in OpenAPI.
	TimestampOfLocationEstimate *externalRef0.DateTime `json:"timestampOfLocationEstimate,omitempty"`

	// Velocity estimate.
	VelocityEstimate *VelocityEstimate `json:"velocityEstimate,omitempty"`
}

// Number of event reports received from the target UE.
type EventReportCounter int

// Duration of event reporting.
type EventReportDuration int

// Indicates an event report message.
type EventReportMessage struct {
	// Specifies event classes.
	EventClass EventClass `json:"eventClass"`

	// This parameter provides information about the referenced binary body data.
	EventContent externalRef0.RefToBinaryData `json:"eventContent"`
}

// Indicates the status of event reporting.
type EventReportingStatus struct {
	// Number of event reports received from the target UE.
	EventReportCounter *EventReportCounter `json:"eventReportCounter,omitempty"`

	// Duration of event reporting.
	EventReportDuration *EventReportDuration `json:"eventReportDuration,omitempty"`
}

// Indicates types of External Clients.
type ExternalClientType string

// Common base type for GAD shapes.
type GADShape struct {
	// Indicates supported GAD shapes.
	Shape SupportedGADShapes `json:"shape"`
}

// Geographic area specified by different shape.
type GeographicArea interface{}

// Geographical coordinates.
type GeographicalCoordinates struct {
	Lat float64 `json:"lat"`
	Lon float64 `json:"lon"`
}

// Global Navigation Satellite System (GNSS) ID.
type GnssId string

// Indicates the usage of a Global Navigation Satellite System (GNSS) positioning method.
type GnssPositioningMethodAndUsage struct {
	// Global Navigation Satellite System (GNSS) ID.
	Gnss GnssId `json:"gnss"`

	// Indicates supported modes used for positioning method.
	Mode PositioningMode `json:"mode"`

	// Indicates usage made of the location measurement.
	Usage Usage `json:"usage"`
}

// Indicates value of horizontal speed.
type HorizontalSpeed float32

// Horizontal velocity.
type HorizontalVelocity struct {
	// Indicates value of angle.
	Bearing Angle `json:"bearing"`

	// Indicates value of horizontal speed.
	HSpeed HorizontalSpeed `json:"hSpeed"`
}

// Horizontal velocity with speed uncertainty.
type HorizontalVelocityWithUncertainty struct {
	// Indicates value of angle.
	Bearing Angle `json:"bearing"`

	// Indicates value of horizontal speed.
	HSpeed HorizontalSpeed `json:"hSpeed"`

	// Indicates value of speed uncertainty.
	HUncertainty SpeedUncertainty `json:"hUncertainty"`
}

// Horizontal and vertical velocity.
type HorizontalWithVerticalVelocity struct {
	// Indicates value of angle.
	Bearing Angle `json:"bearing"`

	// Indicates value of horizontal speed.
	HSpeed HorizontalSpeed `json:"hSpeed"`

	// Indicates direction of vertical speed.
	VDirection VerticalDirection `json:"vDirection"`

	// Indicates value of vertical speed.
	VSpeed VerticalSpeed `json:"vSpeed"`
}

// Horizontal and vertical velocity with speed uncertainty.
type HorizontalWithVerticalVelocityAndUncertainty struct {
	// Indicates value of angle.
	Bearing Angle `json:"bearing"`

	// Indicates value of horizontal speed.
	HSpeed HorizontalSpeed `json:"hSpeed"`

	// Indicates value of speed uncertainty.
	HUncertainty SpeedUncertainty `json:"hUncertainty"`

	// Indicates direction of vertical speed.
	VDirection VerticalDirection `json:"vDirection"`

	// Indicates value of vertical speed.
	VSpeed VerticalSpeed `json:"vSpeed"`

	// Indicates value of speed uncertainty.
	VUncertainty SpeedUncertainty `json:"vUncertainty"`
}

// Indicates value of the inner radius.
type InnerRadius int32

// Information within Determine Location Request.
type InputData struct {
	// String uniquely identifying a NF instance. The format of the NF Instance ID shall be a  Universally Unique Identifier (UUID) version 4, as described in IETF RFC 4122.
	AmfId *externalRef0.NfInstanceId `json:"amfId,omitempty"`

	// Indicates the information of area based event reporting.
	AreaEventInfo *AreaEventInfo `json:"areaEventInfo,omitempty"`

	// LCS Correlation ID.
	CorrelationID *CorrelationID `json:"correlationID,omitempty"`

	// Contains the ECGI (E-UTRAN Cell Global Identity), as described in 3GPP 23.003
	Ecgi *externalRef0.Ecgi `json:"ecgi,omitempty"`

	// Contains the ECGI (E-UTRAN Cell Global Identity), as described in 3GPP 23.003
	EcgiOnSecondNode *externalRef0.Ecgi `json:"ecgiOnSecondNode,omitempty"`

	// Indicates types of External Clients.
	ExternalClientType *ExternalClientType `json:"externalClientType,omitempty"`

	// String identifying a Gpsi shall contain either an External Id or an MSISDN.  It shall be formatted as follows -External Identifier= "extid-<extid>, where <extid>  shall be formatted according to clause 19.7.2 of 3GPP TS 23.003 that describes an  External Identifier.
	Gpsi *externalRef0.Gpsi `json:"gpsi,omitempty"`

	// String providing an URI formatted according to RFC 3986
	HgmlcCallBackURI *externalRef0.Uri `json:"hgmlcCallBackURI,omitempty"`

	// LCS service type.
	LcsServiceType *LcsServiceType `json:"lcsServiceType,omitempty"`

	// LDR Reference.
	LdrReference *LdrReference `json:"ldrReference,omitempty"`

	// Indicates LDR types.
	LdrType *LdrType `json:"ldrType,omitempty"`

	// QoS of Location request.
	LocationQoS *LocationQoS `json:"locationQoS,omitempty"`

	// This parameter provides information about the referenced binary body data.
	LppMessage *externalRef0.RefToBinaryData `json:"lppMessage,omitempty"`

	// Indicates the lpp message extension.
	LppMessageExt *[]externalRef0.RefToBinaryData `json:"lppMessageExt,omitempty"`

	// Indicates the information of motion based event reporting.
	MotionEventInfo *MotionEventInfo `json:"motionEventInfo,omitempty"`

	// Contains the NCGI (NR Cell Global Identity), as described in 3GPP 23.003
	Ncgi *externalRef0.Ncgi `json:"ncgi,omitempty"`

	// Contains the NCGI (NR Cell Global Identity), as described in 3GPP 23.003
	NcgiOnSecondNode *externalRef0.Ncgi `json:"ncgiOnSecondNode,omitempty"`

	// String representing a Permanent Equipment Identifier that may contain - an IMEI or IMEISV, as  specified in clause 6.2 of 3GPP TS 23.003; a MAC address for a 5G-RG or FN-RG via wireline  access, with an indication that this address cannot be trusted for regulatory purpose if this  address cannot be used as an Equipment Identifier of the FN-RG, as specified in clause 4.7.7  of 3GPP TS23.316. Examples are imei-012345678901234 or imeisv-0123456789012345.
	Pei *externalRef0.Pei `json:"pei,omitempty"`

	// Indicates the information of periodic event reporting.
	PeriodicEventInfo *PeriodicEventInfo `json:"periodicEventInfo,omitempty"`

	// Indicates priority of the LCS client.
	Priority             *LcsPriority           `json:"priority,omitempty"`
	ReportingAccessTypes *[]ReportingAccessType `json:"reportingAccessTypes,omitempty"`

	// String identifying a Supi that shall contain either an IMSI, a network specific identifier, a Global Cable Identifier (GCI) or a Global Line Identifier (GLI) as specified in clause 2.2A of 3GPP TS 23.003. It shall be formatted as follows
	//  - for an IMSI "imsi-<imsi>", where <imsi> shall be formatted according to clause 2.2 of 3GPP TS 23.003 that describes an IMSI.
	//  - for a network specific identifier "nai-<nai>, where <nai> shall be formatted according to clause 28.7.2 of 3GPP TS 23.003 that describes an NAI.
	//  - for a GCI "gci-<gci>", where <gci> shall be formatted according to clause 28.15.2 of 3GPP TS 23.003.
	//  - for a GLI "gli-<gli>", where <gli> shall be formatted according to clause 28.16.2 of 3GPP TS 23.003.To enable that the value is used as part of an URI, the string shall only contain characters allowed according to the "lower-with-hyphen" naming convention defined in 3GPP TS 29.501.
	Supi *externalRef0.Supi `json:"supi,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures  *externalRef0.SupportedFeatures `json:"supportedFeatures,omitempty"`
	SupportedGADShapes *[]SupportedGADShapes           `json:"supportedGADShapes,omitempty"`

	// Contain the TNAP Identifier see clause5.6.2 of 3GPP TS 23.501.
	TnapId *externalRef0.TnapId `json:"tnapId,omitempty"`

	// Contain the TWAP Identifier as defined in clause 4.2.8.5.3 of 3GPP TS 23.501.
	TwapId *externalRef0.TwapId `json:"twapId,omitempty"`

	// Indicates the connectivity state of a UE.
	UeConnectivityStates *UeConnectivityState `json:"ueConnectivityStates,omitempty"`
	UeCountryDetInd      *bool                `json:"ueCountryDetInd,omitempty"`

	// Indicates the LCS capability supported by the UE..
	UeLcsCap *UeLcsCapability `json:"ueLcsCap,omitempty"`

	// Specifies location service types requested by UE.
	UeLocationServiceInd *UeLocationServiceInd `json:"ueLocationServiceInd,omitempty"`

	// Positioning capabilities supported by the UE. A string encoding the "ProvideCapabilities-r9-IEs" IE as specified in clause 6.3 of 3GPP TS 37.355 (start from octet 1).
	UePositioningCap *UePositioningCapabilities `json:"uePositioningCap,omitempty"`

	// Indicates velocity requirement.
	VelocityRequested *VelocityRequested `json:"velocityRequested,omitempty"`

	// String providing an URI formatted according to RFC 3986
	VgmlcAddress *externalRef0.Uri `json:"vgmlcAddress,omitempty"`
}

// LMF identification.
type LMFIdentification string

// Indicates priority of the LCS client.
type LcsPriority string

// Specifies LCS QoS class.
type LcsQosClass string

// LCS service type.
type LcsServiceType int

// LDR Reference.
type LdrReference string

// Indicates LDR types.
type LdrType string

// Minimum straight line distance moved by a UE to trigger a motion event report.
type LinearDistance int

// Information within Transfer Location Context Request.
type LocContextData struct {
	// String uniquely identifying a NF instance. The format of the NF Instance ID shall be a  Universally Unique Identifier (UUID) version 4, as described in IETF RFC 4122.
	AmfId externalRef0.NfInstanceId `json:"amfId"`

	// Indicates the information of area based event reporting.
	AreaEventInfo       *AreaEventInfo `json:"areaEventInfo,omitempty"`
	CIoT5GSOptimisation *bool          `json:"cIoT5GSOptimisation,omitempty"`

	// Contains the ECGI (E-UTRAN Cell Global Identity), as described in 3GPP 23.003
	Ecgi *externalRef0.Ecgi `json:"ecgi,omitempty"`

	// Indicates an event report message.
	EventReportMessage EventReportMessage `json:"eventReportMessage"`

	// Indicates the status of event reporting.
	EventReportingStatus *EventReportingStatus `json:"eventReportingStatus,omitempty"`

	// String identifying a Gpsi shall contain either an External Id or an MSISDN.  It shall be formatted as follows -External Identifier= "extid-<extid>, where <extid>  shall be formatted according to clause 19.7.2 of 3GPP TS 23.003 that describes an  External Identifier.
	Gpsi *externalRef0.Gpsi `json:"gpsi,omitempty"`

	// Globally Unique AMF Identifier constructed out of PLMN, Network and AMF identity.
	Guami *externalRef0.Guami `json:"guami,omitempty"`

	// String providing an URI formatted according to RFC 3986
	HgmlcCallBackURI externalRef0.Uri `json:"hgmlcCallBackURI"`

	// LDR Reference.
	LdrReference LdrReference `json:"ldrReference"`

	// Indicates LDR types.
	LdrType LdrType `json:"ldrType"`

	// QoS of Location request.
	LocationQoS *LocationQoS `json:"locationQoS,omitempty"`

	// Indicates the information of motion based event reporting.
	MotionEventInfo *MotionEventInfo `json:"motionEventInfo,omitempty"`

	// Contains the NCGI (NR Cell Global Identity), as described in 3GPP 23.003
	Ncgi *externalRef0.Ncgi `json:"ncgi,omitempty"`

	// Indicates the information of periodic event reporting.
	PeriodicEventInfo *PeriodicEventInfo `json:"periodicEventInfo,omitempty"`

	// String identifying a Supi that shall contain either an IMSI, a network specific identifier, a Global Cable Identifier (GCI) or a Global Line Identifier (GLI) as specified in clause 2.2A of 3GPP TS 23.003. It shall be formatted as follows
	//  - for an IMSI "imsi-<imsi>", where <imsi> shall be formatted according to clause 2.2 of 3GPP TS 23.003 that describes an IMSI.
	//  - for a network specific identifier "nai-<nai>, where <nai> shall be formatted according to clause 28.7.2 of 3GPP TS 23.003 that describes an NAI.
	//  - for a GCI "gci-<gci>", where <gci> shall be formatted according to clause 28.15.2 of 3GPP TS 23.003.
	//  - for a GLI "gli-<gli>", where <gli> shall be formatted according to clause 28.16.2 of 3GPP TS 23.003.To enable that the value is used as part of an URI, the string shall only contain characters allowed according to the "lower-with-hyphen" naming convention defined in 3GPP TS 29.501.
	Supi *externalRef0.Supi `json:"supi,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures  *externalRef0.SupportedFeatures `json:"supportedFeatures,omitempty"`
	SupportedGADShapes *[]SupportedGADShapes           `json:"supportedGADShapes,omitempty"`

	// Indicates location information of a UE.
	UeLocationInfo *UELocationInfo `json:"ueLocationInfo,omitempty"`

	// Positioning capabilities supported by the UE. A string encoding the "ProvideCapabilities-r9-IEs" IE as specified in clause 6.3 of 3GPP TS 37.355 (start from octet 1).
	UePositioningCap *UePositioningCapabilities `json:"uePositioningCap,omitempty"`
}

// Local area specified by different shape
type LocalArea interface{}

// Indicates a Local origin in a reference system
type LocalOrigin struct {
	CoordinateId *string `json:"coordinateId,omitempty"`

	// Geographical coordinates.
	Point *GeographicalCoordinates `json:"point,omitempty"`
}

// Information within Determine Location Response.
type LocationData struct {
	// Indicates fulfilment of requested accuracy.
	AccuracyFulfilmentIndicator *AccuracyFulfilmentIndicator `json:"accuracyFulfilmentIndicator,omitempty"`

	// Contain Minor Location QoS.
	AchievedQos *MinorLocationQoS `json:"achievedQos,omitempty"`

	// Indicates value of the age of the location estimate.
	AgeOfLocationEstimate *AgeOfLocationEstimate `json:"ageOfLocationEstimate,omitempty"`

	// Indicates value of altitude.
	Altitude *Altitude `json:"altitude,omitempty"`

	// Specifies the measured uncompensated atmospheric pressure.
	BarometricPressure *BarometricPressure `json:"barometricPressure,omitempty"`

	// Indicates a Civic address.
	CivicAddress *CivicAddress `json:"civicAddress,omitempty"`

	// Contains the ECGI (E-UTRAN Cell Global Identity), as described in 3GPP 23.003
	Ecgi                    *externalRef0.Ecgi               `json:"ecgi,omitempty"`
	GnssPositioningDataList *[]GnssPositioningMethodAndUsage `json:"gnssPositioningDataList,omitempty"`

	// Local area specified by different shape
	LocalLocationEstimate *LocalArea `json:"localLocationEstimate,omitempty"`

	// Geographic area specified by different shape.
	LocationEstimate GeographicArea `json:"locationEstimate"`

	// Contains the NCGI (NR Cell Global Identity), as described in 3GPP 23.003
	Ncgi                *externalRef0.Ncgi           `json:"ncgi,omitempty"`
	PositioningDataList *[]PositioningMethodAndUsage `json:"positioningDataList,omitempty"`

	// LMF identification.
	ServingLMFIdentification *LMFIdentification `json:"servingLMFIdentification,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures *externalRef0.SupportedFeatures `json:"supportedFeatures,omitempty"`

	// string with format 'date-time' as defined in OpenAPI.
	TimestampOfLocationEstimate *externalRef0.DateTime `json:"timestampOfLocationEstimate,omitempty"`

	// Positioning capabilities supported by the UE. A string encoding the "ProvideCapabilities-r9-IEs" IE as specified in clause 6.3 of 3GPP TS 37.355 (start from octet 1).
	UePositioningCap *UePositioningCapabilities `json:"uePositioningCap,omitempty"`

	// Velocity estimate.
	VelocityEstimate *VelocityEstimate `json:"velocityEstimate,omitempty"`
}

// QoS of Location request.
type LocationQoS struct {
	// Indicates value of accuracy.
	HAccuracy *Accuracy `json:"hAccuracy,omitempty"`

	// Specifies LCS QoS class.
	LcsQosClass   *LcsQosClass        `json:"lcsQosClass,omitempty"`
	MinorLocQoses *[]MinorLocationQoS `json:"minorLocQoses,omitempty"`

	// Indicates acceptable delay of location request.
	ResponseTime *ResponseTime `json:"responseTime,omitempty"`

	// Indicates value of accuracy.
	VAccuracy         *Accuracy `json:"vAccuracy,omitempty"`
	VerticalRequested *bool     `json:"verticalRequested,omitempty"`
}

// Maximum interval between event reports.
type MaximumInterval int

// Minimum interval between event reports.
type MinimumInterval int

// Contain Minor Location QoS.
type MinorLocationQoS struct {
	// Indicates value of accuracy.
	HAccuracy *Accuracy `json:"hAccuracy,omitempty"`

	// Indicates value of accuracy.
	VAccuracy *Accuracy `json:"vAccuracy,omitempty"`
}

// Indicates the information of motion based event reporting.
type MotionEventInfo struct {
	// Minimum straight line distance moved by a UE to trigger a motion event report.
	LinearDistance LinearDistance `json:"linearDistance"`

	// Maximum interval between event reports.
	MaximumInterval *MaximumInterval `json:"maximumInterval,omitempty"`

	// Minimum interval between event reports.
	MinimumInterval *MinimumInterval `json:"minimumInterval,omitempty"`

	// Specifies occurrence of event reporting.
	OccurrenceInfo *OccurrenceInfo `json:"occurrenceInfo,omitempty"`

	// Maximum duration of event reporting.
	ReportingDuration    *ReportingDuration `json:"reportingDuration,omitempty"`
	ReportingLocationReq *bool              `json:"reportingLocationReq,omitempty"`

	// Maximum time interval between consecutive evaluations by a UE of a trigger event.
	SamplingInterval *SamplingInterval `json:"samplingInterval,omitempty"`
}

// Specifies occurrence of event reporting.
type OccurrenceInfo string

// Indicates value of orientation angle.
type Orientation int

// Indicates the information of periodic event reporting.
type PeriodicEventInfo struct {
	// Number of required periodic event reports.
	ReportingAmount ReportingAmount `json:"reportingAmount"`

	// Event reporting periodic interval.
	ReportingInterval ReportingInterval `json:"reportingInterval"`
}

// Point defines model for Point.
type Point struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`
}

// PointAltitude defines model for PointAltitude.
type PointAltitude struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of altitude.
	Altitude Altitude `json:"altitude"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`
}

// PointAltitudeUncertainty defines model for PointAltitudeUncertainty.
type PointAltitudeUncertainty struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of altitude.
	Altitude Altitude `json:"altitude"`

	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Indicates value of uncertainty.
	UncertaintyAltitude Uncertainty `json:"uncertaintyAltitude"`

	// Ellipse with uncertainty.
	UncertaintyEllipse UncertaintyEllipse `json:"uncertaintyEllipse"`
}

// List of points.
type PointList []GeographicalCoordinates

// PointUncertaintyCircle defines model for PointUncertaintyCircle.
type PointUncertaintyCircle struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Indicates value of uncertainty.
	Uncertainty Uncertainty `json:"uncertainty"`
}

// PointUncertaintyEllipse defines model for PointUncertaintyEllipse.
type PointUncertaintyEllipse struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Ellipse with uncertainty.
	UncertaintyEllipse UncertaintyEllipse `json:"uncertaintyEllipse"`
}

// Polygon defines model for Polygon.
type Polygon struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// List of points.
	PointList PointList `json:"pointList"`
}

// Indicates supported positioning methods.
type PositioningMethod string

// Indicates the usage of a positioning method.
type PositioningMethodAndUsage struct {
	// Indicates supported positioning methods.
	Method     PositioningMethod `json:"method"`
	MethodCode *int              `json:"methodCode,omitempty"`

	// Indicates supported modes used for positioning method.
	Mode PositioningMode `json:"mode"`

	// Indicates usage made of the location measurement.
	Usage Usage `json:"usage"`
}

// Indicates supported modes used for positioning method.
type PositioningMode string

// Specifies type of event reporting.
type ReportedEventType string

// Specifies access types of event reporting.
type ReportingAccessType string

// Number of required periodic event reports.
type ReportingAmount int

// Indicates an area for event reporting.
type ReportingArea struct {
	// Indicates type of event reporting area.
	AreaType ReportingAreaType `json:"areaType"`

	// Contains the ECGI (E-UTRAN Cell Global Identity), as described in 3GPP 23.003
	Ecgi *externalRef0.Ecgi `json:"ecgi,omitempty"`

	// Contains the NCGI (NR Cell Global Identity), as described in 3GPP 23.003
	Ncgi *externalRef0.Ncgi `json:"ncgi,omitempty"`

	// Contains the tracking area identity as described in 3GPP 23.003
	Tai *externalRef0.Tai `json:"tai,omitempty"`
}

// Indicates type of event reporting area.
type ReportingAreaType string

// Maximum duration of event reporting.
type ReportingDuration int

// Event reporting periodic interval.
type ReportingInterval int

// Indicates acceptable delay of location request.
type ResponseTime string

// Maximum time interval between consecutive evaluations by a UE of a trigger event.
type SamplingInterval int

// Indicates value of speed uncertainty.
type SpeedUncertainty float32

// Indicates supported GAD shapes.
type SupportedGADShapes string

// Specifies causes of event reporting termination.
type TerminationCause string

// Indicates location information of a UE.
type UELocationInfo struct {
	// Indicates value of the age of the location estimate.
	AgeOfLocationEstimate *AgeOfLocationEstimate `json:"ageOfLocationEstimate,omitempty"`

	// Indicates value of the age of the location estimate.
	AgeOfVelocityEstimate *AgeOfLocationEstimate `json:"ageOfVelocityEstimate,omitempty"`

	// Geographic area specified by different shape.
	LocationEstimate *GeographicArea `json:"locationEstimate,omitempty"`

	// string with format 'date-time' as defined in OpenAPI.
	TimestampOfLocationEstimate *externalRef0.DateTime `json:"timestampOfLocationEstimate,omitempty"`

	// string with format 'date-time' as defined in OpenAPI.
	TimestampOfVelocityEstimate *externalRef0.DateTime `json:"timestampOfVelocityEstimate,omitempty"`

	// Velocity estimate.
	VelocityEstimate *VelocityEstimate `json:"velocityEstimate,omitempty"`
}

// Indicates the connectivity state of a UE.
type UeConnectivityState struct {
	// Indicates wether the access is  via 3GPP or via non-3GPP.
	AccessType externalRef0.AccessType `json:"accessType"`
}

// Indicates the LCS capability supported by the UE..
type UeLcsCapability struct {
	CiotOptimisation *bool `json:"ciotOptimisation,omitempty"`
	LppSupport       *bool `json:"lppSupport,omitempty"`
}

// Specifies location service types requested by UE.
type UeLocationServiceInd string

// Positioning capabilities supported by the UE. A string encoding the "ProvideCapabilities-r9-IEs" IE as specified in clause 6.3 of 3GPP TS 37.355 (start from octet 1).
type UePositioningCapabilities []byte

// Indicates value of uncertainty.
type Uncertainty float32

// Ellipse with uncertainty.
type UncertaintyEllipse struct {
	// Indicates value of orientation angle.
	OrientationMajor Orientation `json:"orientationMajor"`

	// Indicates value of uncertainty.
	SemiMajor Uncertainty `json:"semiMajor"`

	// Indicates value of uncertainty.
	SemiMinor Uncertainty `json:"semiMinor"`
}

// Ellipsoid with uncertainty
type UncertaintyEllipsoid struct {
	// Indicates value of orientation angle.
	OrientationMajor Orientation `json:"orientationMajor"`

	// Indicates value of uncertainty.
	SemiMajor Uncertainty `json:"semiMajor"`

	// Indicates value of uncertainty.
	SemiMinor Uncertainty `json:"semiMinor"`

	// Indicates value of uncertainty.
	Vertical Uncertainty `json:"vertical"`
}

// Indicates usage made of the location measurement.
type Usage string

// Velocity estimate.
type VelocityEstimate interface{}

// Indicates velocity requirement.
type VelocityRequested string

// Indicates direction of vertical speed.
type VerticalDirection string

// Indicates value of vertical speed.
type VerticalSpeed float32

// CancelLocationJSONBody defines parameters for CancelLocation.
type CancelLocationJSONBody CancelLocData

// DetermineLocationJSONBody defines parameters for DetermineLocation.
type DetermineLocationJSONBody InputData

// LocationContextTransferJSONBody defines parameters for LocationContextTransfer.
type LocationContextTransferJSONBody LocContextData

// CancelLocationJSONRequestBody defines body for CancelLocation for application/json ContentType.
type CancelLocationJSONRequestBody CancelLocationJSONBody

// DetermineLocationJSONRequestBody defines body for DetermineLocation for application/json ContentType.
type DetermineLocationJSONRequestBody DetermineLocationJSONBody

// LocationContextTransferJSONRequestBody defines body for LocationContextTransfer for application/json ContentType.
type LocationContextTransferJSONRequestBody LocationContextTransferJSONBody

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+w963KcONavomL3x25Vu31LJ2PvL0xjhxoaOkA7k51JUTKo25qhgQHaiTfVD/S9xvdk",
	"X0niIkBc3HY2ma/yJ2nD0ZF0dHR0bjp8kbxoG0chCrNUuvwipd492kL6U/a8XQK9R/LbR6mX4DjDUShd",
	"SlroYw9mKAUPMNghEK0BzIGn0kRaR8kWZtKltA4imEkTaYtDvN1tpcuTiZQ9xki6lMLd9g4l0n5SdnO9",
	"C9Y42KIwy9FHSV/P6xKcdJ+gP3cozZBfGwgKSae/Spb6bqXajjp3ZUVZWbLywb1e6dearqtzaSJ6bZgO",
	"B/KxHHaaJTjc0GFvkLnWIw+SkalphrcwQ6NIld0jADflzyDHAVCOhIx8Cz8zip2fvXn9RkhBHGZok5Mw",
	"yHC288d1D3Pg2kr50e4uQH0dH+UP2usXboKRPRPI+uxenwzOLUFQfaBcsY76uiG0xCGbESEn6TBBENzB",
	"FPkAERQgQXGUZDjckFHESRSjJMOIcjuBnaM1DjHD/EXCGdrSV39P0Fq6lP52XG2V43yfHFsFRjJOMt4t",
	"/KyxhmczNrn8z9NydjBJ4GMOS2auhRlKHmAw1NeiAb4vaTcaQwN8P5Eisl8SFHqoIHAfArMOvZ9IJUnn",
	"uwQWpBtFsbIBj6XYURb6ky32Gu6CTLrMkh0qCXgXRQGCtGEKt3GAw81YCthN+D3t/c8dTpBPZEWDD6qt",
	"H939jryM9HkFk2iLsgR7ywSl6S4RsL8dIw+vcc6XWwQJmA92IRkTClNIZVW2jdL4HiXYA3GOqrY/Tk9n",
	"Jyf8Fjk/oX+3t4kCQw8FeuTNYQZF26TaGJ9wdo9DwFqAguDAYiK0vTPuN9vAU2AQXEHvj5WlcSR27LOL",
	"2ZtTV4m22ygkXU8f4TYQUn6VYDLQwE8stEaUh4YWS+dhyWLvYsImyL9GMNslKD1wKHYLT5MLWnNuDFzE",
	"Fgp+wJ7s+2Qh+wQVBBQSQAbaJrh8Sv5tnzhn4sfn4sevxI9n4sevxY/nc8Wcq8J3V/pc+Pxat4TP3xpm",
	"x3Nb+Fxf/Cx+birC54a8ED5fKh2PDfFzvQPevDJ/6Xgz73jeMSCrA94Sw3eAW/Mrq+OFrSpdb1ZXXa3M",
	"juHaquyIXzjihVsZmriBF+3CLHkUvtui7D7yha/iJHrAPvKvxC13KdwgaxewvdN4vRft0yhcY7+QP4Na",
	"i1eC10XzyaDqokRJggIqXbV5uy9dsQEHArR53oGOwk12TxSIGe2i+PtUoIaqQYDjNMK+nHhUjQkCcy1d",
	"/tovWG/kuX0PYyJUvzSEj1ejTh8Sjo77iYRDL9j5yC/Vwb6mDIi2ClFiQR/vBjUtjQMlest6naLsab3F",
	"EQ6zIegbFG0SGN9jDwZKFCU+DglDUFYLPZRkEIfZ47gxr6oGrSOGDaZOAlEX9ak2CT3hF6x9Kn2cNJiu",
	"5BcgJ96UchDRjJUAig6tSoth+rNHwFDK21b2arnU1YVqOLL1wbVV61ZTVFtoMtGejCjD68fRWgptA1ij",
	"bhUFevcYPSD/XZSOUIGjpFB63kU2GRjssuV6uUrYiGDjrLFeBAUcEY0N3aF33/Gw+4m0CdN0GaVUXyVq",
	"NcygjtNstAlzU2+/oJJYDv0VEay5kdFtw2ziFB+oht2QpvvJd6RgEls8eCojEPigMP+CJzaupE2BIX7G",
	"Uh6+jMwAQz7dbw59OcaM4xsQBR0lD8SIW1wTiZThNfZG2YT64lqrN2DaPj5cwcdf2WCYSBlKtuRswFGo",
	"wF06SDGnCU9w4C1KM7iNe+XPU4Y6hxly8JZif0BB5OHscSwz3jbhm2dWm0tG2EUUmLGLQjRAJPDrGdSd",
	"RNQt3lGTggR5CD8gH6yTaEtN6QwmG5SBlVrTxn56/eqkbimfijQybii8u6I+luJNczS52+gZfS5QSjdj",
	"n3EY1voEW9akfeSh2rHdt6rcAb+f5O2iMEM1VegpLGahtRNd4RAm7Bxvcgk3tEZ/A+yBw42dwWyXDvn5",
	"UgrVsUACOrW4b5Be9RYF3dqsMxJR5esSWSTq5wwlIQyUAHPSt5MAjzGicy+aAdauppapC9W6UQ2FU8km",
	"0q2sr1RXns/VOf94qS8M11yqluyYFv9Cl99fr3RXMxzVUtSl093oyjLluSLbPSDmovVINkzjw8Jc2a7t",
	"yI5mO5rSbufI1o3quAu7QO0SldO0HKGOWVo2LQIyzqbuYEpCsI4ScCPPQUrgKfF8TBpQIc2CD1sYxwTx",
	"5RdJ1XVtaZva3JUtpXPFeWtsIi1NzXC6z2qm/1MgV9YdzVnN1V7oUmNstnJXhqJajqwZzodRGHjDpEDG",
	"4XAVzVL0/sFwKBSceAESImJkG42JEZCh0j/cmEZ3w+Bxw/SEfL8/GnBLeSE3bBtyIC24otc7XJzzBRu1",
	"PYMMj0iQNVQ5YpaEjyOMccYIxBIfhGrT/KnNCgIPtyvoOwI/Z8k8AbpmHA80rG2stlVbkZ7FfNLcbvXB",
	"3SPw8ZqqJxnb6dP6WtWN/JbU4AGBV0G2D5oA0vO0J6R2wesKRxeiYGjATpUeJKc/1bDQPxtoGhxLcE7o",
	"8IRcG6ap5gsmHkR3MAAGfMAbpg7ZMENBgDME7Mc0Q1vwjxvDtv+Z+62Kg+dmSUT4jaxrumpKE8m+ksmD",
	"hTlXLUP7tzp3GcS7f9sUUDcNmf66mpN/DflWU8SSvddMHVAYqJOQhgTB+Ilxlhhg/sn2qhPje4yBrfnU",
	"BIuG3QL8HCPmHdgVU+z1NTE7r7H4tEfmI5AKRCI2eBsl+D9RmMHAjhHyR3lG78s2ZMMhXxz7Lxj37OTV",
	"m4FUgGoQhSXSHkcFAwrzpr0qdwgm+bk9yjF4X066D7xJo1bQiD2elN33E7qY43uc3fOycMyUqXuMUR1w",
	"LsNvRomJ1JxC7zFLGvX5RluUbODvJywh6C0hgTeSkWDog4e8wbfnqon0MMcJ8saYGMU0qwak+ah+i6Yj",
	"eblEWxve0xeCSOyRzC5clv9vnP9tVnsiPXzl/SrilgatGoMQ8ZJWjw+Nyq2iARWQ0Ea1IwmH2flZK8dp",
	"NhTG08J4l40OWMwR8wsiYWZFGFElseYt8TaYvCH/fWyZLXC71vwD/TTGWgvTDIYeYtoHbKZS9e6LGjCN",
	"3jaimf2xQR54P2GzPGwaKmmaozBDG3lR6Bt1ReogdEKnS68R0m7xXQZAvNRGyQP20JhJ6XXo5wZQ/GRU",
	"pzkYFzB5F9ljAi1c1C6IY86h+hJ+TB6n+jkbMiqCOC78s4BwU5jiKCS7vBmreeag+nMIIxo0GLutFw3w",
	"fS55DpQw+V4KX2ZrFuhidOiAlihHkODIx95osixbDagkxlGCh49H3UuXBSifyyh7HkpTwujpAfmkZeNB",
	"FvjeA2Vp26s2lhwih9wANbIQxgcfmQ5rTNB8eg6aTwWaHVKiMCT6zwPOHu2s8DL1WvLtNgUqmkA1R5kW",
	"8rlSXD7sDuleqsB4uA8GB+9wkPPtDhUCNj8Q8k4G0LTbUFycG2PUcOrwbFiYLXeh+ltFkv/YOGbVgGAh",
	"h2w7xeLJB6wogNOOX7ezvRbXoB4UJydFO7uRkyU9x08hmgqdV1ds4FG1hPfFvdVu3qq24y4tzbQ054M0",
	"kQzTWsh69eSjeAzvonQwJYj0+S6yWVIQ3+0V6VO9vjYtR5pIsm2vLHrPYrHSHW2pq+470+7quKG5tDPm",
	"UgZAQzj1hLyzwXsSekOzaWCfW6B83UjFm52e1FLxzkSjr3SfrmUjXdDwHU+ulerKt7Kmy1e6Kk2kpWpp",
	"5lxTpImkGo5qacaNqxmO6cqWKksTSVflW/Ls2jIXxbMrlUHZ2lwtni1MRzMNMZ1xiGAyx8w4aA84vyYA",
	"0iyBeHOfgYDYM34OD7bRA/OsQ7BSQRaBLMGbDUoABEwbqUVlm1mTwxFzPfJowPjzeKvLSWCYrlFSGV05",
	"hp6cse/HstIiZ3Zjm3GGtzjl5Ed+92ENg1R4+eEljCphdsLIqHbRoo6nFsUfialq8zIW1WYHtwfjoG2/",
	"r7y0/6JZ9V0YFC+jwP9QjHnFuNLvxhB0pdagX1ana965oqK4YvPJ4P0boeASORCr5Mz2eU9eDceLSyxm",
	"gjc47L/Zw3BGFBLgEECQFGMGKQ0uts6hKqisddx/eFbW+r6DKGTwz3NqpnEUpkiUjN17obf3aOxpSo7Z",
	"v3qa953w5mBfa8Fdw2emi7+A0vBtM86/hyTtlzjivkmed5Whrb1IhvZXTK/+qqnRX8VB8WJ51i0G/dgj",
	"xXMVry7EiWEerStxnXTe7uXLPIyRzXmIgfcQDDhHS1DGnFQuv4vSJ2g7ImnOXbQfvNvAjiq69oP+Vw6W",
	"LO0h5CmC1jWHVdN8Ex3Mi3ZBgIZlzgAAziHAHco+IVS3uNN2mvqQyb1o1xEQuwSe0HGzgkRXx/WVFeTt",
	"hhnEIaCQFUO/i+wXYuYDlli4dm276QmlKnLHychiFUHLgdO7BevQPwpPfJeFJxprKpL4ZotkXb7Zirgd",
	"lyQK56NpqK6jLVRXvVUNh3fSck9FPkQzwSjMOpzdgsyMqIIXFIKpZ7UKnbdLkUvgCTuscCkM764qgLeN",
	"dsOml9UA57lqLHdYrQbiq1dVL6JORDyzLKzHZ98Mf7Yd2r79/KQLy3Qm03JOfNGjZ8/tEGPuK9CDsyqf",
	"RBrammXGVeWdmoRqJHx9E5odWl3gBW/uyyOH3cjS27XvUIxHUN66GFp1YT/i4R9+81/ALTTXkusFoAK6",
	"4qPCQm140XBKK7BRpKko++Wpa1Up9qczXrM/b2v2HZdivr20qy3ZS1SJ2PUmSo5bbH59PUqpqYiIHHt/",
	"s2oiL0j9l9+twi36Apuxvf+KBWJ3sV6MrYudPHhViwIKyUDfjJhoPvZ8Hg2vVZ8GV/qWBNdwauFzRdV1",
	"bS5NJFWh/5nO3KQxcdkyF6pjaYq7tFSahCBNpPe6bJCX+kp1TNN5SzTeK7sMl7u2atimJU2kue7miOa6",
	"K5tl/sKR5RA12bDcvL9VCbgigOSHoTrvTetn116qinbdcZ/pJe4yjbmhVFVWepJHsSrKpOQJfZVhf8pb",
	"9a9Fyvo3uOjERj0pbjx1X3Vq9juKCQnWFOyIdb6Okg7CcxkdV7JNc15WqivbtmY79C/FNIhBpZmGrAuZ",
	"whKV4eisLPgYD5l3RTJJad6VKSWypcrl0yKnpPawlVRS2Yhsr5R/yr9oi9WC3RO/lXVX/WWpWXINRjcV",
	"9kCRDbJj+bfdhKjnQfaQAlKo6mp8D0kMsrvVlWPJrmIahqo46tx1THd2o9D8KMM9v1kuhe8sl91pNCx3",
	"Ufy4KX6YzlvVcm15aD6lTdlVAaPgarHF2nTunV9cXFwMednqVUr7y0/QgCjh8VElU8eXisl7LxIUXiAM",
	"9QJBmAweisGBWFg7lM5PJHbaVBio8SDgY7o4tTIPS9t1LFn5udy92pwIGJrrpx4RLjdcst/cG928kvX8",
	"9bXGdqM0kWY3PRgMS9C4I2vQEvnjxN5r/2UrrFgib0tD32rQsdxahT/7sF1Vjyt0birPQ3EG7wIEfBRA",
	"mrQZCAIzxaLq5nt3ruoyWQH6v+uYumrJVJAaZv5OtAa2wCkpXoIMb1Hbme+R6Xi7DD8ggB5gsKNjTMtc",
	"P6p0FNl+dOWa5ZwHF6t1l2yM81B43a/nqvFsNnDT2BZm3gyrAfV6IeUpS+t89NTR6KuMUZW6aNUC6S3z",
	"MWmUJGFnrO6ezd2+zhjQeTeQqYkLnjuCclddx7FHAEQHMeCKZvEUdFRroRlMKbj64K7ISBvPcqW6ymHm",
	"3gsH3Mhg6lnfcjM264fnZaYax97LppGQF7dPDCB3Ynt+ZsPXDbtz2Hvm/E3rnbUObtF1jAETzeMa0GJV",
	"qIedagruARTgbwo1FZLq1UfhzOqXQAZmRS8ZlNCcVLx7pO9X6rQ9PQ9H2dMzm4M4zkX0iGCceNHEl1m6",
	"JFYpAvj7BSn3XYm7x3z1qlM6t2hU29EWsqPyVg6z+Yip485lRxbLp86UktY4OcBqBXDtZKrWAMiAdQJQ",
	"6EU+lbr3CPwmLVkhZb6ro+TiSFPT3ySgqQCmXCIkDoEXEDEOXk/PCfcSqwg4Njh/Mz2fzcA/0gwmGavL",
	"F3kZysDpP2un8t1jhkQ3XJ569g+e+n3nvNitKfLFoZYPrs3LXAxzAX8fTmfkY6Q092qLR7VrhB5oOxw+",
	"sV2zblXZOY9w0p6TUFA0yRhhv4uQEfZbpPxrU7JK6PkaC1DiHrsWQz5C5h/cQr/9iZn8OxTbxj2xlWGv",
	"FEWlZZjyX66l2ivdsemXcFbMl9V8RR67juneqpZ2/cEthF8P5I1qqJbsqCLYheq8Nee0v7nKdLuOT++I",
	"NIc6MQoI7ps6XLtaWlan/ClQ5GvYpNmtqpuK5nxwNUaj8iNC0qT2rnounkqzokfPkPwCiKxrWRilLL1U",
	"rubyvWyRYczN9wb92dfz+HJP7R4Pt8DoXvR2CVGoyN7JpYK8y+7PWHkFJUE03xQG9NU6iD4xfUL0NvWi",
	"3IQLg+36KIg86VKSc59gRPeAEWzXbpk9Ji81qo5Gf6BwlQTSpfQlTNZyjK0oyvbHESQDOaava/oFfS7t",
	"91z9iHnkCU7s4rQ8u5jO3pyB29M301fTk3+B2U1eZOxfVSrbAoZwQxkM5MpK+i9gZ2QXn0sTaUfHd59l",
	"8eXx8adPn6bnmzieRsnmeJ3Fx0SFSY9h4t3jB3R8duGmKMEoPWYdH7Mi+yLzR19cV0PI+53+Fv7v/4Cz",
	"k7OzCTvvzWQDQ/wfCgQDsIRJFqIkBf+QLe1qAmRHsydAUWx5AlTH1ibAsef0P0cm/yj/nP4WykEAEry5",
	"p+V8iXqF/OlvIVENcBagxkiYQEzZEE+nZ9OTIxjE93D6iuaMxSiEMSb0nZ5MT8ixArN7Sv5jj37P5qiQ",
	"dSzYxeJc5ORhhqAvXVafyik6zJW8q8h/zGOWRXFcGMdBnu98/HvKkDJZPxjOrH2PZ18/DIgay+Wl0vGf",
	"nbwSnKifY+QR7a4AJdwMQbqjrL3eBYDNOihPxvOTN080I8pRHJO2FMVPz0DxE0Hx6uTkYBSkLUVx+gwU",
	"pwzF+TNQnDMUr56BgvLsq9NnTOSUTeT0GRM5ZRM5nT0DxYyiOLs4HMXZBUExewZfzBhfzJ6xqDO2qLNn",
	"LOqMLWppkR6IpmhPD8LddguTR+myEES1TV1LXYySwvuK/FKrI5IUblIaC69/00v6SPAf+8XtLaFw9GAQ",
	"3EHvDyqFuE90kD+//L1wT99F/uPfjpvX8vY8oq8hRpufDKGCtC4jVyr/kRDudsrB4vUBBtgHYQPdD8n6",
	"Q7L+kKx/Icm6p8KirvuVF1m/svpX1QwkY9juggzHMMmOaVE8Zm8Vzjlaq7Ks96XXiprlY3HytEduOA+h",
	"z+yAII6liXSPoI8SKunyby0csdvE1XCbX0YjAxP1q37OTr9h32f/jb7JYhaXn7v7oktOT+gSWaPEaMey",
	"VT5QCiDygvIjGM9IDWfQGKvi5MV4unZrXHAQ956m+SYjUx95FK+jBCzMI90q2uJwU3myYJoW5Wh8IhF+",
	"nNA/TugfJ/Rf2PYRlJignwwHNBegMHDaULmNUwiGI4/VfTrK8opQ3X6gAkNeKaooIfWVNIJGUasX9Qhx",
	"/qBSQOZ0ACUdfgjIHwLyh4D86wrIYiOXO5tPVqI56WO9RK0aeaXo+7jnIzPS5a9f9pOesMyvVbjl4/4j",
	"Ky5CtfFfv+RRiy+wCKkUkMcPp9JEeoAJhnf5N5tzmFqmB413pJfHx+gz3MYBmnrRVmpqnHlDAFPgozUO",
	"a2kLr6av+LSFs4vpjOz8/f7j/v8CAAD//92eyvb1hAAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
